
sub userinfo {
    my ($r,$args,$cfg) = @_;
    $cfg = Apache::ModuleConfig->get($r) unless $cfg;
    my $gidenv = $cfg->{gidenv};
    if($r->auth_type eq 'Basic') {
	$args->{user}=$r->user;
    } elsif($cfg->{userenv}) {
	$args->{user}=$r->subprocess_env($cfg->{userenv});
    } else {
	$args->{user}='';
    }
    $args->{gid}=[split /[,:;]|$;/,$r->subprocess_env($gidenv)];
    if($debug) {
	print STDERR "userinfo() user=$args->{user} admin=$cfg->{admin} gidenv=$gidenv\n";
	if(@{$args->{gid}}) {
	    print STDERR " gid=";
	    for(my $cnt=@{$args->{gid}}-1;$cnt>=0;$cnt--) {
		print STDERR "{$args->{gid}}[$cnt],";
	    }
	    print STDERR "\n";
	}
    }
    for(my $cnt=@{$args->{gid}}-1;$cnt>=0; $cnt--) {
	if($args->{gid}[$cnt]=~m:[^0-9]:o) {	# if a number, look-up the group name
	    $args->{gidname}[$cnt]=$args->{gid}[$cnt];
	    $args->{gid}[$cnt]=getgrnam $args->{gidname}[$cnt];
	} else {
	    $args->{gidname}[$cnt]=getgrgid $args->{gid}[$cnt] || $args->{gid}[$cnt];
	}
    }
}

